Name:      libevent
Version:   2.0.21
Release:   3
Summary:   Abstract asynchronous event notification library
Group:     System Environment/Libraries
License:   BSD
URL:       http://monkey.org/~provos/libevent/
Source0:   http://monkey.org/~provos/%{name}-%{version}-stable.tar.gz
Source1:   http://monkey.org/~provos/%{name}-%{version}-stable.tar.gz.asc
Source2:   libevent-1.4.so.2-aix32
Source3:   libevent-1.4.so.2-aix64
Source4:   libevent_core-1.4.so.2-aix32
Source5:   libevent_core-1.4.so.2-aix64
Source6:   libevent_extra-1.4.so.2-aix32
Source7:   libevent_extra-1.4.so.2-aix64
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: openssl-devel >= 1.0.2j-2

Requires:      openssl >= 1.0.2j-2

%description
The libevent API provides a mechanism to execute a callback function
when a specific event occurs on a file descriptor or after a timeout
has been reached. libevent is meant to replace the asynchronous event
loop found in event driven network servers. An application just needs
to call event_dispatch() and can then add or remove events dynamically
without having to change the event loop.

The library is available as 32-bit and 64-bit.


%package devel
Summary: Header files, libraries and development documentation for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: python

%description devel
This package contains the header files, static libraries and development
documentation for %{name}. If you like to develop programs using %{name},
you will need to install %{name}-devel.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "cc_r -q64" or "gcc -maix64".


%prep
%setup -q -n %{name}-%{version}-stable


%build
export CONFIG_SHELL=/usr/bin/ksh
export CONFIG_ENV_ARGS=/usr/bin/ksh

# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

# first build the 64-bit version
export CC="cc_r -q64"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static
make %{?_smp_mflags}

cp .libs/%{name}-2.0.so.5 .
cp .libs/%{name}_core-2.0.so.5 .
cp .libs/%{name}_extra-2.0.so.5 .
cp .libs/%{name}_pthreads-2.0.so.5 .
cp .libs/%{name}_openssl-2.0.so.5 .
make distclean

# now build the 32-bit version
export CC="cc_r"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static
make %{?_smp_mflags}

# add the 64-bit shared objects to the shared library containing already the
# 32-bit shared objects
${AR} -q .libs/%{name}-2.0.a          ./%{name}-2.0.so.5
${AR} -q .libs/%{name}_core-2.0.a     ./%{name}_core-2.0.so.5
${AR} -q .libs/%{name}_extra-2.0.a    ./%{name}_extra-2.0.so.5
${AR} -q .libs/%{name}_pthreads-2.0.a ./%{name}_pthreads-2.0.so.5
${AR} -q .libs/%{name}_openssl-2.0.a  ./%{name}_openssl-2.0.so.5

# Add the older 1.4 14 shared members for compatibility with older apps
# (make sure they're set for LOADONLY with 'strip -e')
cp %{SOURCE2} libevent-1.4.so.2
/usr/bin/strip -X32 -e libevent-1.4.so.2
/usr/bin/ar -X32 -q .libs/%{name}-2.0.a libevent-1.4.so.2
cp %{SOURCE3} libevent-1.4.so.2
/usr/bin/strip -X64 -e libevent-1.4.so.2
/usr/bin/ar -X64 -q .libs/%{name}-2.0.a libevent-1.4.so.2

cp %{SOURCE4} libevent_core-1.4.so.2
/usr/bin/strip -X32 -e libevent_core-1.4.so.2
/usr/bin/ar -X32 -q .libs/%{name}_core-2.0.a libevent_core-1.4.so.2
cp %{SOURCE5} libevent_core-1.4.so.2
/usr/bin/strip -X64 -e libevent_core-1.4.so.2
/usr/bin/ar -X64 -q .libs/%{name}_core-2.0.a libevent_core-1.4.so.2

cp %{SOURCE6} libevent_extra-1.4.so.2
/usr/bin/strip -X32 -e libevent_extra-1.4.so.2
/usr/bin/ar -X32 -q .libs/%{name}_extra-2.0.a libevent_extra-1.4.so.2
cp %{SOURCE7} libevent_extra-1.4.so.2
/usr/bin/strip -X64 -e libevent_extra-1.4.so.2
/usr/bin/ar -X64 -q .libs/%{name}_extra-2.0.a libevent_extra-1.4.so.2


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib
  do
    mkdir -p usr/$dir
    cd usr/$dir
    ln -sf ../..%{_prefix}/$dir/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc README
%{_libdir}/*.a
/usr/lib/*.a


%files devel
%defattr(-,root,system,-)
%doc sample/*.c
%{_bindir}/*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir}/pkgconfig/*.pc
/usr/bin/*
/usr/include/*
/usr/lib/*.la


%changelog
* Wed Nov 16 2016 Michael Perzl <michael@perzl.org> - 2.0.21-3
- recompiled against latest versions

* Fri Mar 04 2016 Michael Perzl <michael@perzl.org> - 2.0.21-2
- recompiled against latest version of openssl

* Tue Jan 08 2013 Michael Perzl <michael@perzl.org> - 2.0.21-1
- updated to version 2.0.21

* Thu Oct 11 2012 Michael Perzl <michael@perzl.org> - 2.0.20-1
- updated to version 2.0.20

* Tue May 29 2012 Michael Perzl <michael@perzl.org> - 2.0.19-1
- updated to version 2.0.19

* Tue Mar 20 2012 Michael Perzl <michael@perzl.org> - 2.0.17-1
- updated to version 2.0.17

* Mon Jul 19 2010 Michael Perzl <michael@perzl.org> - 1.4.14b-1
- updated to version 1.4.14b

* Tue Dec 01 2009 Michael Perzl <michael@perzl.org> - 1.4.13-1
- updated to version 1.4.13

* Thu Jul 23 2009 Michael Perzl <michael@perzl.org> - 1.4.11-1
- updated to version 1.4.11

* Mon Aug 11 2008 Michael Perzl <michael@perzl.org> - 1.4.6-1
- updated to version 1.4.6

* Mon Jul 14 2008 Michael Perzl <michael@perzl.org> - 1.4.5-1
- first version for AIX V5.1 and higher
